/* 
*   Function:  build up  internal data structures for netlist 
*
*   Author:    Prof Jason Cong,  Dongmin Xu 
*	       Computer Sci. Dept., UCLA, CA 90095
*
* Copyright (C) 1997 Regents of the University of California
* All rights reserved.
*/ 

/* for internal use only */

#ifndef		MEM_ARRAY_INC
#define	 MEM_ARRAY_INC			1000
#endif
#ifndef		MAX_HASH_SIZE			/* cannot be too small */
#define	 MAX_HASH_SIZE			5000
#endif



typedef struct netlist_int NETLIST_INT, Netlist_int;
typedef struct binary_tree_node BINARY_TREE_NODE, Binary_tree_node;


struct netlist_int		/* for internal use */
{
   int   np;		/* # of pins in the circuit */
   Pin  *pins;		/* pin array */

   int   ne;		/* # of equivalent pins in the circuit */
   Epin  *epins;	/* equivalent pin array */

   int   ns;		/* # of shapes in the circuit */
   Shape *shapes;	/* shape array */

   int   nn;		/* # of nodes */
   Binary_tree_node *nodes;	/* binary tree node array */
};


struct binary_tree_node		/* for internal use */
{
   char  *name;		/* net name */
   int   index;	/* pointer to net */

   Binary_tree_node   *left,  *right;
};



#ifndef  USE_IT_ONLY_ONCE

extern  Netlist_int   *netlist_int;		/* hold the netlist */
extern  Binary_tree_node   *binary_tree_root;	/* hold all net names */

extern  int   avail_cell_array_size;
extern  int   avail_net_array_size;
extern  int   avail_pad_array_size;
extern  int   avail_pin_array_size;
extern  int   avail_epin_array_size;
extern  int   avail_shape_array_size;
extern  int   avail_node_array_size;

#else

Netlist_int   *netlist_int=NULL;		/* hold the netlist */
Binary_tree_node   *binary_tree_root=NULL;	/* hold all net names */

int   avail_cell_array_size = 0;
int   avail_net_array_size = 0;
int   avail_pad_array_size = 0;
int   avail_pin_array_size = 0;
int   avail_epin_array_size = 0;
int   avail_shape_array_size = 0;
int   avail_node_array_size = 0;

#endif


